<?php

// Jukebox Playtime Fix script
// Distributed with Jukebox 0.5.4.0

// - Place this script in Jukebox's root folder.
// - Run this script until it reports it is complete.
// - Remove this script from the root folder.

// This script will take a long time to run on a large database.  If you have MP3s on the Remote File Server, it will take even longer.  Your browser will keep trying to load the page, like it has stalled, until the script is complete.  Be patient, and do not interrupt your web browser while the script is running.

require_once("include/settings.php");
require_once("include/database.php");
require_once("include/getid3/getid3.php"); // The 3rd-party script that looks up track meta data

define("TRACKS_DIR", "tracks/");

dbconn();

$start_time = time();

$query = sprintf(
	"SELECT `id`, `title`, `md5`, `uploaded` FROM %s WHERE ABS(`playtime` - ROUND(`playtime`)) < 0.00001 ORDER BY `id`",
		$audio_tables['tracks']
	);
$result = mysql_query($query) or sqlerrorhandler("(".mysql_errno().") ".mysql_error(), $query, $_SERVER['PHP_SELF'], __LINE__);

if(mysql_num_rows($result) > 0) {
	print("Performning playtime re-calculation.  This will take awhile...<BR />\n");
	print("<B></U>IMPORTANT:</U></B> If this script ends abrubtly without reporting that the upgrade script completed, please refresh your browser in order to continue the upgrade process.<BR />\n");
	$getID3 = new getID3;
	
	while($row = mysql_fetch_array($result)) {
		set_time_limit(120);
		$track_subfolders = "";
		for($i = 0; $i < $folder_depth; $i++) {
			$track_subfolders .= $row['md5'][$i] . "/";
		}
		if($row['uploaded']) {
			$remote_file = "ftp://" . $ftp_user . ":" . $ftp_pass . "@" . $ftp_host . "/" . $ftp_subfolder . $track_subfolders . $row['md5'] . ".mp3";
			$target_file = "temp/test_" . $row['id'] . ".mp3";
			$copy_attempts = 0;
			do {
				$copy_attempts++;
				copy($remote_file, $target_file);
			} while(!is_file($target_file) && $copy_attempts <= 2);
			if(!is_file($target_file)) {
				die(sprintf("Failed to copy file %s to to %s", $remote_file, $target_file));
			}
		} else {
			$target_file = TRACKS_DIR . $track_subfolders . $row['md5'] . ".mp3";
		}
		
		printf("Updating '%s' of ID #%d...", $row['title'], $row['id']);
		if(!is_file($target_file)) {
			die(sprintf("File %s does not exist!", $target_file));
		}

		$track_info = $getID3->analyze($target_file);
		if($row['uploaded']) {
			unlink($target_file);
		}
		getid3_lib::CopyTagsToComments($track_info);
		$track_info['playtime_seconds'];
		
		$query = sprintf("UPDATE %s SET `playtime` = %f WHERE `id` = %d", $audio_tables['tracks'], $track_info['playtime_seconds'], $row['id']);
		mysql_query($query) or sqlerrorhandler("(".mysql_errno().") ".mysql_error(), $query, $_SERVER['PHP_SELF'], __LINE__);
		print("complete!<BR />\n");
	}
}

$end_time = time();

printf("<BR />Upgrade script complete!  Operation took %d seconds.<BR />\n", $end_time - $start_time);

?>
